/*
 *    Copyright 2019 Frederic Thevenet
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package eu.binjr.common.javafx.controls;

import javafx.scene.Node;
import javafx.scene.SnapshotParameters;
import javafx.scene.image.WritableImage;
import javafx.scene.transform.Transform;
import javafx.stage.Screen;

public final class SnapshotUtils {

    public static WritableImage outputScaleAwareSnapshot(Node node) {
        return scaledSnapshot(node, 0.0,0.0);
    }

    public static WritableImage scaledSnapshot(Node node, double scaleX, double scaleY) {
        SnapshotParameters spa = new SnapshotParameters();
        spa.setTransform(Transform.scale(
                scaleX == 0.0 ? Screen.getPrimary().getOutputScaleX() : scaleX,
                scaleY == 0.0 ? Screen.getPrimary().getOutputScaleY() : scaleY));
        return node.snapshot(spa, null);
    }
}
